      program gimupcfh
C........................................................Oct 2024
C IRI-Plas-CCIR median GIM-foF2,  GIM-hmF2,  GIM-TEC,
C........................................................Apr. 2024
C Input: current day uadg	GIM_TEC
C........................................................Dec 2023
C Day-to-day running instant UADG
C........................................................Oct. 2021
C 1) read GIM-TEC IONEX for 00, 15, 30, 45 min 
C........................................................Jan. 2019
C UPC maps IONEX glat x glon; 00, 15, 30, 45 minutes
C
C infilerz='R12.dat'
C .......................................................
C
      DIMENSION IM(12),rzi(12)				! rzi = 12-month smoothed SSN1
      integer IYR,IMN,IDY,IUT,daynr
CC      CHARACTER*16 indate
	      CHARACTER*1 qs
      	CHARACTER*4 AYEAR,CYEAR,TIME
	CHARACTER*2 AYR,AMM  ! minute
	+,AUT,AMN,ADY
	CHARACTER*1 fht
	CHARACTER(10) DD,infilerz
      CHARACTER(10) TT
      CHARACTER(5) ZZ
         COMMON /CONST/UMR,PI 
      COMMON /DAN/RZ,daynr,dnr,imap,irun,qs,iutend,immend
C  irun=1 (TECobs); =2(TEC-CCIR0; =3 (foF2-CCIR); =4 (hmF2-CCIR)
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C
C
        PI=ATAN(1.0)*4.
        UMR=PI/180.
C+    write(*,*) ' Enter <c> or <u>:'
C+	read(*,*) qs
	qs='c'  ! current day UADG NORM
C+      	qs='u'  !  change date for UQRG
C+
CC  799	format(I4,2(1X,I2),1X,I4,2(1X,I2),2(1X,I3))				 !+++
CC  798	format(' YEAR, AMN, ADY = ',A4,2(1X,A2),1X,A4,2(1X,A2),2(1X,I3))
CC	indate='c:/web/graf/date'    !!! Tamara !!!!!!!	 !FEB2015
CC  111	open(10,file=indate)							   !FEB2015			
CC	read(10,799) KYEAR,KMN,KDY,KYEAR_pre,KMN_pre,KDY_pre  !+++
CC	+,lda_cur,lda_pre  ! lda: day-of-year
CC	close(unit=10)
C
      CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
	AYEAR=DD(1:4)
	AYR=AYEAR(3:4)
	AMN=DD(5:6)
	ADY=DD(7:8)
      TT(5:)='      '
	TIME=tt(1:4)
C
       read(AYEAR,*) ryear
	kyear=int(ryear)
	kyr=kyear-kyear/100*100
C++
      read(AMN,*) rmn
      kmn=int(rmn)
      read(ADY,*) rdy
      kdy=int(rdy)
C++
C++-------------------------------------------------
CC Read sunspot number RZ for the current month
  797 FORMAT(1X,A4,1X,12(1X,F5.1))
      infilerz='R12.dat'
	OPEN(10,file=infilerz,action='READ')
  796	read(10,797) CYEAR,rzi
	if (CYEAR.eq.AYEAR) then
	goto 795
	                   else
	goto 796
	                   endif
  795 close(10)
      	RZ=RZI(kmn)            ! SSN1_12
C
C----------------------------------------------------
103	lda=ndoy(kyr,kmn,kdy)         ! uadg for the current day:lda = day-of-year
      daynr=lda
      imn=kmn
	IYEAR=KYEAR
       iyr=kyr
C
   13 FORMAT(I2)
C
      idy=kdy
C++
	z1=iyear/4.0
      jz=int(z1)*4
      IF(jz.EQ.iyear) THEN
               IM(2)=29
	dnr=366.
	ndnr=366
        ELSE
                IM(2)=28
	  	dnr=365.
	ndnr=365
	       ENDIF
C++
 201	CONTINUE		 ! cycle on days
C
   17 format (A2)
C
200   continue	  
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
       ndmn=im(imn)
C
C  Start cycle on UT		=======================================================================
C
  104       iutend=23
        immend=45
C
	fht='t'				! only TEC source map
      lda1=lda
C
      imap=0
C
      DO 300 iut=0,iutend   ! norm
	call blet2(iut,AUT)
C add 
		ut=float(iut)
C
C Start cycle on minutes
C
      immend=45
C
      DO 301 imm=0,immend,15	  ! norm
CREM	 imm=45  ! temp
      call blet2(imm,AMM)
	imap=imap+1
C
	IRUN=0 ! NORMAL COMMAND
      DO WHILE (IRUN.lt.5)
  100 IRUN=IRUN+1
C  IRUN = 1 read instant GIM-TECob qs = 'c' uadg ('u' uqrg) 
C  IRUN = 2 read GIM-TEC-CCIR
C  IRUN = 3 read GIM-foF2-CCIR
C  IRUN = 4 read GIM-hmF2-CCIR
	iutcur=iut
	immcur=imm
            call subtecupc(AYEAR,AMN,ADY,iutcur,immcur) 
      END DO
C
	if ((iut.eq.iutend).and.(imm.eq.immend)) exit
C	
C ------------------------------------------------------
  301 CONTINUE		! end MIN cycle
      if (iut.eq.iutend) exit
C	 
  300 CONTINUE		! end UT cycle
C
    5	iend=1
            write(*,*) ' yr=',AYR,'  mn=',AMN,' day=',idy
	pause ' ' 
      STOP
	END
